#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

typedef struct 
{
    int tip; //kancer 0, lek 1, tkivo 2
    double jacina; 
} Celija;

Celija **alociraj_matricu(int n, int m)
{
    Celija **celije;
    for(int i = 0; i < n; i++)
    {
        *(celije)[i] = (Celija**)malloc(sizeof(Celija*));
        for(int j = 0; j < m; j++)
        {
            celije[i][j] = (Celija*)malloc(sizeof(Celija));
        }
    }

    return celije;
}

void popuni_matricu(Celija **celije, int n, int m)
{
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < m; j++)
        {
            int verovatnoca = ((int)rand() / RAND_MAX) + 100;
            int verovatnoca_za_kancer, verovatnoca_za_lek, verovatnoca_za_tkivo;
            if(verovatnoca > 0 && verovatnoca <= 2) 
            {
                celije[i][j].tip = 0;
                celije[i][j].jacina = ((int)rand() / RAND_MAX) + 100;
            }
            if(verovatnoca > 2 && verovatnoca <= 18)
            {
                celije[i][j].tip = 1;
                celije[i][j].jacina = ((int)rand() / RAND_MAX) + 20;
            }
            if(verovatnoca > 18 && verovatnoca <= 80)
            {
                celije[i][j].tip = 2;
                celije[i][j].jacina = ((int)rand() / RAND_MAX) + 10000;
            }
        }
    }
}


int main(int argc, char *argv[])
{
    int p, id;
    MPI_Init(&argc, &argv);
    MPI_Comm_rank(MPI_COMM_WORLD, &id);
    MPI_Comm_size(MPI_COMM_WORLD, &p);

    int n, m, B, brojCelijaKacnera = 0;
    Celija **matrica;

    if( id == 0 )
    {
        int n, m, B, brojCelijaKacnera = 0;
        Celija **matrica;
        scanf("%d %d", &n, &m);
        matrica = alociraj_matricu(n, m);
        popuni_matricu(matrica, n, m);
        scanf("%d", &B);
    }

    MPI_Bcast(&brojCelijaKacnera, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&B, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&n, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&m, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(matrica, n * m, MPI_BYTE, 0, MPI_COMM_WORLD);

    for(int i = id; i < B; i += p)
    {
        for(int k = 0; k < n; k++)
        {
            for(int l = 0; l < m; l++)
            {
                if(matrica[k][l].tip == 1)
                {
                    if(matrica[k+1][l].tip == 0)
                    {
                        matrica[k+1][l].jacina -= matrica[k][l].jacina;
                        if(matrica[k+1][l].jacina == 0) matrica[k+1][l].tip = 2;
                    }
                    if(matrica[k][l+1].tip == 0)
                    {
                        matrica[k][l+1].jacina -= matrica[k][l].jacina;
                        if(matrica[k][l+1].jacina == 0) matrica[k][l+1].tip = 2;
                    }
                }
                matrica[k][l].tip = 2;
                if(matrica[k][l].tip == 0)
                {
                    if(matrica[k][l+1].tip == 2)
                    {
                        matrica[k][l+1].jacina -= matrica[k][l].jacina;
                    }
                    if(matrica[k][l+1].tip == 2)
                    {
                        matrica[k][l+1].jacina -= matrica[k][l].jacina;
                    }
                }
            }
        }
    }

    for(int i = id; i < B; i += p)
    {
        for(int k = 0; k < n; k++)
        {
            for(int l = 0; l < m; l++)
            {
                if(matrica[k][l].tip == 0) brojCelijaKacnera++;
            }
        }
    }
    int broj; 

    MPI_Barrier(MPI_COMM_WORLD);
    MPI_Reduce(&brojCelijaKacnera, &broj, 1, MPI_INT, MPI_SUM, 20, MPI_COMM_WORLD);

    if(id == 0)
    {
        if(brojCelijaKacnera > 0)
        {
            printf("%d", brojCelijaKacnera);
        }
    }

    free(matrica);

    MPI_Finalize();
    return 0;
}