#include <stdio.h>
#include <stdlib.h>
#include "mpi.h"

#define B 10000

typedef struct celija{
	int tip; //0-kancer,1-lek,2-tkivo
	int jacina;//za 0-[0,100], za 1-[1,20], za 2-[0,10000]
}Celija;

typedef struct polje{
	int tip;
	int jacina;
}Polje;

int main(int argc, char *argv[]){
	int id,np;
	MPI_Init(&argc,&argv);
	MPI_Comm_rank(MPI_COMM_WORLD,&id);
	MPI_Comm_size(MPI_COMM_WORLD,&np);
	
	int m,n;
	int i,j,k;
	int **polje;
	int brCelijaKancera,globalBrCelijaKancera;
	Celija *celije, *globalCelije;
	int jacina,globalJacina;
	int maxJacina=0;
	int brSusedaKancera;
	
	if(id==0){
		scanf("%d%d", &m,&n);
		for(i=0;i<m;i++){
			for(j=0;j<n;j++){
				int r=rand()%3;
				polje[i][j]=r;
			}
		}
	}
	MPI_Bcast(&m,1,MPI_INT,0,MPI_COMM_WORLD);
	MPI_Bcast(&n,1,MPI_INT,0,MPI_COMM_WORLD);
	MPI_Bcast(polje,m*n,MPI_INT,0,MPI_COMM_WORLD);
	
	celije=(Celija *)calloc(m*n,sizeof(Celija));
	globalCelije=(Celija *)calloc(m*n,sizeof(Celija));
	
	//postavlja se koji je tip celije i njena jacina;
	k=0;
	for(i=0;i<m;i++){
		for(j=0;j<n;j++){
			celije[k].tip=polje[i][j];
			switch(polje[i][j]){
				case 0:
					celije[k].jacina=(rand()/RAND_MAX)*100;
					break;
				case 1:
					celije[k].jacina=(rand()/RAND_MAX)*19+1;
					break;
				case 2:
					celije[k].jacina=(rand()/RAND_MAX)*10000;
					break;
			}
			k++;
		}
	}
	MPI_Bcast(&k,1,MPI_INT,0,MPI_COMM_WORLD);
	
	MPI_Allreduce(celije,globalCelije,k,MPI_INT,MPI_SUM,MPI_COMM_WORLD);
	
	int brKanc=0,globalKanc;
	
	for(i=0;i<k;i++){
		if(celije[k].tip==0)
			brKanc++;
	}
	MPI_Reduce(&brKanc,&globalKanc,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);
	
	int mm,nn;
	mm=m;
	nn=n/np;
	/*for(int ii=id;i<B;i+=np){
		for(i=0;i<mm;i++){
			for(j=0;j<nn;j++){
				switch(polje[i][j]){
					case 0:
						if(polje[i-1][j-1]==2)
							celije[k-m-1].jacina-=celije[k].jacina;
						if(polje[i-1][j]==2)
							celije[k-m].jacina-=celije[k].jacina;
						if(polje[i-1][j+1]==2)
							celije[k-m+1].jacina-=celije[k].jacina;
						if(polje[i][j-1]==2)
							celije[k-1].jacina-=celije[k].jacina;
						if(polje[i][j+1]==2)
							celije[k+1].jacina-=celije[k].jacina;
						if(polje[i+1][j-1]==2)
							celije[k+m-1].jacina-=celije[k].jacina;
						if(polje[i+1][j]==2)
							celije[k+m].jacina-=celije[k].jacina;
						if(polje[i+1][j+1]==2)
							celije[k+m+1].jacina-=celije[k].jacina;
						break;
					case 1:
						brSusedaKancera=0;
						if(polje[i-1][j-1]==0){
							celije[k-m-1].jacina-=celije[k].jacina;
							if(celije[k-m-1].jacina==0){
								celije[k-m-1].tip=2;
								brKanc--;
							}
							brSusedaKancera++;
						}
						if(polje[i-1][j]==0){
							celije[k-m].jacina-=celije[k].jacina;
							if(celije[k-m].jacina==0){
								celije[k-m].tip=2;
								brKanc--;
							}
							brSusedaKancera++;
						}	
						if(polje[i-1][j+1]==0){
							celije[k-m+1].jacina-=celije[k].jacina;
							celije[k-m+1].jacina-=celije[k].jacina;
							if(celije[k-m+1].jacina==0){
								celije[k-m+1].tip=2;
								brKanc--;
							}
							brSusedaKancera++;
						}	
						if(polje[i][j-1]==2){
							celije[k-1].jacina-=celije[k].jacina;
							if(celije[k-1].jacina==0){
								celije[k-1].tip=2;
								brKanc--;
							}
							brSusedaKancera++;
						}	
						if(polje[i][j+1]==2){
							celije[k+1].jacina-=celije[k].jacina;
							if(celije[k+1].jacina==0){
								celije[k+1].tip=2;
								brKanc--;
							}
							brSusedaKancera++;
						}	
						if(polje[i+1][j-1]==2){
							celije[k+m-1].jacina-=celije[k].jacina;
							if(celije[k+m-1].jacina==0){
								celije[k+m-1].tip=2;
								brKanc--;
							}
							brSusedaKancera++;
						}	
						if(polje[i+1][j]==2){
							celije[k+m].jacina-=celije[k].jacina;
							if(celije[k+m].jacina==0){
								celije[k+m].tip=2;
								brKanc--;
							}
							brSusedaKancera++;
						}	
						if(polje[i+1][j+1]==2)
							celije[k+m+1].jacina-=celije[k].jacina;
							if(celije[k+m+1].jacina==0){
								celije[k+m+1].tip=2;
								brKanc--;
							}
							brSusedaKancera++;
						}
						if(brSusedaKancera==0)
								celije[k].tip==2;
						break;
						
				}
			}
		}
	}
	MPI_Allreduce(celije,globalCelije,k,MPI_INT,MPI_SUM,MPI_COMM_WORLD);
	*/
	MPI_Status status;
	
	for(i=0;i<k;i++){
		if(celije[i].tip==0 && celije[i].jacina>maxJacina)
			maxJacina=celije[i].jacina;
	}
	
	MPI_Reduce(&jacina,&globalJacina,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);
	int ukupno=0;
	if(id!=0){
		MPI_Send(&brKanc,1,MPI,INT,0,17,MPI_COMM_WORLD);
	}
	else{
		for(int l=0;l<np;i++){
			ukupno=brKanc;
			MPI_Recv(&ukupno,1,MPI_INT,i,17,MPI_COMM_WORLD);
			ukupno+=brKanc;
		}
	}
	
	if(id==0){
		printf("Ukupno ima %d kancera, jacina najjaceg je!%d\n",ukupno,globalJacina);
	}
		
	MPI_Finalize();
	return 0;
}
